
#include ".\fbimage\fbimage.bi"

enum TColor
  clEmpty
  clWhite
  clBlack
end enum

type TFourInARowGraphics
  as integer w1, l1, t1, c1
  as any ptr pngEmpty, pngWhite, pngBlack
  declare sub Initialize(_
    as integer,_
    as integer,_
    as integer,_
    as integer,_
    as string,_
    as string,_
    as string)
  declare sub FreeImages
  declare sub DrawPiece(as integer, as integer, as TColor)
  declare sub DrawGrid
  declare sub InsertPiece(as integer, as integer, as TColor)
end type

sub TFourInARowGraphics.Initialize(_
  aw1 as integer,_
  al1 as integer,_
  at1 as integer,_
  ac1 as integer,_
  afn1 as string,_
  afn2 as string,_
  afn3 as string)
  w1 = aw1
  l1 = al1
  t1 = at1
  c1 = ac1
  pngEmpty = LoadRGBAFile(afn1)
  pngWhite = LoadRGBAFile(afn2)
  pngBlack = LoadRGBAFile(afn3)
end sub

sub TFourInARowGraphics.FreeImages
  ImageDestroy pngEmpty
  ImageDestroy pngWhite
  ImageDestroy pngBlack
end sub

sub TFourInARowGraphics.DrawPiece(x as integer, y as integer, c as TColor)
  dim as integer x1 = w1 * x + l1, y1 = t1 + 7 * w1 - (w1 * y)
  'line (x1 - w2, y1 - w2)-(x1 + w2, y1 + w2), c, bf
  dim png as any ptr
  select case c
    case clWhite
      png = pngWhite
    case clBlack
      png = pngBlack
    case clEmpty
      png = pngEmpty
  end select
  put (l1 + w1 * x - w1 \ 2, t1 + 7 * w1 - (w1 * y) - w1 \ 2), png, ALPHA
end sub

sub TFourInARowGraphics.DrawGrid
  line (l1, t1)-(l1 + 8 * w1, t1 + 7 * w1), c1, bf
  for x as integer = 1 to 7
    for y as integer = 1 to 6
      DrawPiece(x, y, clEmpty)
    next y
  next x
end sub

sub TFourInARowGraphics.InsertPiece(x as integer, y as integer, c as TColor)
  const pause = 40
  for y1 as integer = 6 to y step -1
    if y1 < 6 then
      DrawPiece(x, y1 + 1, clEmpty)
    end if
    DrawPiece(x, y1, c)
    sleep pause
  next y1
end sub
